var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { EVMContractAddress, SnickerdoodleWalletContractError, } from "@snickerdoodlelabs/objects";
import { injectable } from "inversify";
import { ok, ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { P256VerificationData, ContractsAbis, } from "../interfaces/objects/index.js";
let SnickerdoodleWalletContract = class SnickerdoodleWalletContract extends BaseContract {
    constructor(providerOrSigner, contractAddress) {
        super(providerOrSigner, contractAddress, ContractsAbis.SnickerdoodleWalletAbi.abi);
        this.providerOrSigner = providerOrSigner;
        this.contractAddress = contractAddress;
    }
    factoryAddress() {
        return ResultAsync.fromPromise(this.contract.factory(), (e) => {
            return this.generateError(e, "Unable to call factory()");
        });
    }
    operatorAddress() {
        return ResultAsync.fromPromise(this.contract.operatorAddress(), (e) => {
            return this.generateError(e, "Unable to call operatorAddress()");
        });
    }
    addP256KeyWithP256Key(keyId, authenticatorData, clientDataJSON, newP256Key, p256Signature, overrides) {
        return this.writeToContract("addP256KeyWithP256Key", [
            keyId,
            new P256VerificationData(authenticatorData, clientDataJSON.clientDataJSONLeft, clientDataJSON.clientDataJSONRight),
            newP256Key,
            p256Signature,
        ], overrides);
    }
    generateAddP256KeyWithP256KeyChallenge(newKeyId, newP256PublicKey) {
        throw new Error("Method not implemented.");
    }
    addEVMAddressWithP256Key(keyId, authenticatorData, clientDataJSON, evmAccount, p256Signature, overrides) {
        return this.writeToContract("addEVMAddressWithP256Key", [
            keyId,
            new P256VerificationData(authenticatorData, clientDataJSON.clientDataJSONLeft, clientDataJSON.clientDataJSONRight),
            evmAccount,
            p256Signature,
        ], overrides);
    }
    generateAddEVMAddressWithP256KeyChallenge(evmAccountAddress) {
        throw new Error("Method not implemented.");
    }
    addEVMAccountWithEVMAccount(evmAccount, overrides) {
        return this.writeToContract("addEVMAccountWithEVMAccount", [evmAccount], overrides);
    }
    removeEVMAccountWithEVMAccount(evmAccount, overrides) {
        return this.writeToContract("removeEVMAccountWithEVMAccount", [evmAccount], overrides);
    }
    withdrawLocalERC20Asset(tokenAddress, overrides) {
        return this.writeToContract("withdrawLocalERC20Asset", [tokenAddress], overrides);
    }
    generateXWithP256challenge() {
        return ok("");
    }
    generateContractSpecificError(msg, e, transaction) {
        return new SnickerdoodleWalletContractError(msg, e, transaction);
    }
};
SnickerdoodleWalletContract = __decorate([
    injectable(),
    __metadata("design:paramtypes", [Object, String])
], SnickerdoodleWalletContract);
export { SnickerdoodleWalletContract };
//# sourceMappingURL=SnickerdoodleWalletContract.js.map